Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.xml
Class QXmlSimpleReader

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.xml.QXmlReader
                      com.trolltech.qt.xml.QXmlSimpleReader

All Implemented Interfaces:
  QtJambiInterface

    public class QXmlSimpleReader

extends QXmlReader

The `QXmlSimpleReader` class provides an implementation of a simple XML parser. This XML reader is suitable for a wide range of applications. It is able to parse well-formed XML and can report the namespaces of elements to a content handler; however, it does not parse any external entities. For historical reasons, Attribute Value Normalization and End-of-Line Handling as described in the XML 1.0 specification is not performed.

The easiest pattern of use for this class is to create a reader instance, define an input source, specify the handlers to be used by the reader, and parse the data.

For example, we could use a `QFile` to supply the input. Here, we create a reader, and define an input source to be used by the reader:

            QXmlSimpleReader xmlReader = new QXmlSimpleReader();
            QXmlInputSource source = new QXmlInputSource(file);

A handler lets us perform actions when the reader encounters certain types of content, or if errors in the input are found. The reader must be told which handler to use for each type of event. For many common applications, we can create a custom handler by subclassing `QXmlDefaultHandler`, and use this to handle both error and content events:

            Handler handler = new Handler();
            xmlReader.setContentHandler(handler);
            xmlReader.setErrorHandler(handler);

If you don't set at least the content and error handlers, the parser will fall back on its default behavior---and will do nothing.

The most convenient way to handle the input is to read it in a single pass using the `parse()` function with an argument that specifies the input source:

            boolean ok = xmlReader.parse(source);

            if (!ok)
                System.err.println("Parsing failed.");

If you can't parse the entire input in one go (for example, it is huge, or is being delivered over a network connection), data can be fed to the parser in pieces. This is achieved by telling `parse()` to work incrementally, and making subsequent calls to the `parseContinue()` function, until all the data has been processed.

A common way to perform incremental parsing is to connect the `readyRead()` signal of the input source to a slot, and handle the incoming data there. For example, the following code shows how a parser for RSS feeds can be used to incrementally parse data that it receives from a `QHttp` object:

    void readData(QHttpResponseHeader resp)
    {
        boolean sok;

        if (resp.statusCode() != 200)
            http.abort();
        else {
            xmlInput.setData(http.readAll());

            if (newInformation) {
                ok = xmlReader.parse(xmlInput, true);
                newInformation = false;
            }
            else
                ok = xmlReader.parseContinue();

            if (!ok)
                http.abort();
        }
    }

Aspects of the parsing behavior can be adapted using `setFeature()` and setProperty(). For example, the following code could be used to enable reporting of namespace prefixes to the content handler:

`QXmlSimpleReader` is not reentrant. If you want to use the class in threaded code, lock the code using `QXmlSimpleReader` with a locking mechanism, such as a `QMutex`.

###

            xmlReader.setFeature("http://xml.org/sax/features/namespace-prefixes", true);

    Nested Class Summary

    Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter

    QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9

    Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal

    com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal

    Field Summary

    Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal

    currentSender

    Constructor Summary

    QXmlSimpleReader()

               Constructs a simple XML reader.

    Method Summary

     boolean
    parse(QXmlInputSource input,
          boolean incremental)

              Reads an XML document from input and parses it.

     boolean
    parseContinue()

              Continues incremental parsing, taking input from the QXmlInputSource that was specified with the most recent call to parse().

    Methods inherited from class com.trolltech.qt.xml.QXmlReader

    contentHandler, declHandler, DTDHandler, entityResolver, errorHandler, feature, hasFeature, hasProperty, lexicalHandler, parse, setContentHandler, setDeclHandler, setDTDHandler, setEntityResolver, setErrorHandler, setFeature, setLexicalHandler

    Methods inherited from class com.trolltech.qt.QtJambiObject

    dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr

    Methods inherited from class com.trolltech.qt.QSignalEmitter

    blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread

    Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal

    __qt_signalInitialization

    Methods inherited from class java.lang.Object

    clone, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait

    Methods inherited from interface com.trolltech.qt.QtJambiInterface

    disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership

    Constructor Detail

    QXmlSimpleReader

    public QXmlSimpleReader()

Constructs a simple XML reader.

Method Detail

### parse

    public boolean parse(QXmlInputSource input,
                         boolean incremental)

  Reads an XML document from `input` and parses it. Returns true if the parsing is completed successfully; otherwise returns false, indicating that an error occurred.

  If `incremental` is false, this function will return false if the XML file is not read completely. The parsing cannot be continued in this case.

  If `incremental` is true, the parser does not return false if it reaches the end of the `input` before reaching the end of the XML file. Instead, it stores the state of the parser so that parsing can be continued later when more data is available. In such a case, you can use the function `parseContinue()` to continue with parsing. This class stores a pointer to the input source `input` and the `parseContinue()` function tries to read from that input source. Therefore, you should not delete the input source `input` until you no longer need to call `parseContinue()`.

  If this function is called with `incremental` set to true while an incremental parse is in progress, a new parsing session will be started, and the previous session will be lost.

See also:
  `parseContinue()`, and `QTcpSocket`.

### parseContinue

    public boolean parseContinue()

  Continues incremental parsing, taking input from the `QXmlInputSource` that was specified with the most recent call to `parse()`. To use this function, you must have called `parse()` with the incremental argument set to true.

  Returns false if a parsing error occurs; otherwise returns true, even if the end of the XML file has not been reached. You can continue parsing at a later stage by calling this function again when there is more data available to parse.

  Calling this function when there is no data available in the input source indicates to the reader that the end of the XML file has been reached. If the input supplied up to this point was not well-formed then a parsing error occurs, and false is returned. If the input supplied was well-formed, true is returned. It is important to end the input in this way because it allows you to reuse the reader to parse other XML files.

  Calling this function after the end of file has been reached, but without available data will cause false to be returned whether the previous input was well-formed or not.

See also:
  `parse()`, `QXmlInputSource::data()`, and `QXmlInputSource::next()`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD